var YoutubempEngine=YoutubempEngine||{};

YoutubempEngine.gmCompiler={

  getUrlContents: function(url) {
      var	ioService=Components.classes['@mozilla.org/network/io-service;1']
      .getService(Components.interfaces.nsIIOService);
      var	scriptableStream=Components
      .classes['@mozilla.org/scriptableinputstream;1']
      .getService(Components.interfaces.nsIScriptableInputStream);
      var unicodeConverter=Components
      .classes['@mozilla.org/intl/scriptableunicodeconverter']
      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      unicodeConverter.charset='UTF-8';

      var	channel=ioService.newChannel(url, 'UTF-8', null);
      var	input=channel.open();
      scriptableStream.init(input);
      var	str=scriptableStream.read(input.available());
      scriptableStream.close();
      input.close();

      try {
      return unicodeConverter.ConvertToUnicode(str);
      } catch (e) {
      return str;
      }
  },

  contentLoad: function(e) {
      var unsafeWin=e.target.defaultView;
      if (unsafeWin.wrappedJSObject) {
        unsafeWin=unsafeWin.wrappedJSObject;
      }
      var unsafeLoc=new XPCNativeWrapper(unsafeWin, 'location').location;
      var href=new XPCNativeWrapper(unsafeLoc, 'href').href;
      var scheme=Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService).extractScheme(href);
      if ((scheme=='http'||scheme=='https') && /^https?:\/\/.*\.youtube\.com\/watch\?.*/.test(href)) { // inject script
        var safeWin=new XPCNativeWrapper(unsafeWin);
        var sandbox=new Components.utils.Sandbox(safeWin);
        sandbox.window=safeWin;
        sandbox.document=sandbox.window.document;
        sandbox.unsafeWindow=unsafeWin;
        sandbox.XPathResult=Components.interfaces.nsIDOMXPathResult;                            
        sandbox.__proto__=sandbox.window;
        try {
            var script=YoutubempEngine.gmCompiler.getUrlContents('chrome://youtubemp/content/script.js');
            Components.utils.evalInSandbox('(function(){'+script+'})()', sandbox);
        } catch (e) { }
      }
  },

  onLoad: function() {
      var appcontent=window.document.getElementById('appcontent');
      if (appcontent && !appcontent.greased_youtubemp_gmCompiler) {
          appcontent.greased_youtubemp_gmCompiler=true;
          appcontent.addEventListener('DOMContentLoaded', YoutubempEngine.gmCompiler.contentLoad, false);
      }
  },

  onUnLoad: function() {
      window.removeEventListener('load', YoutubempEngine.gmCompiler.onLoad, false);
      window.removeEventListener('unload', YoutubempEngine.gmCompiler.onUnLoad, false);
      window.document.getElementById('appcontent').removeEventListener('DOMContentLoaded', youtubemp_gmCompiler.contentLoad, false);
  },

};

window.addEventListener('load', YoutubempEngine.gmCompiler.onLoad, false);
window.addEventListener('unload', YoutubempEngine.gmCompiler.onUnLoad, false);
